package server;

import servlet.Servlet;
import util.IOCloseUtil;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class Server {//服务器，用于启动和停止
    private ServerSocket server;

    public static void main(String[] args) {
        Server server = new Server();
        server.start();
    }
    public void start(){
        this.start(8888);
    }
    public void start(int port){
        try {
            server = new ServerSocket(port);
            this.receice();        //      调用接收请求信息的方法
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void receice() {
        try {
            //(1)监听
            Socket client = server.accept();

            //封装请求信息
            Request req = new Request(client.getInputStream());
            /*做出响应*/
          /*  StringBuilder sb = new StringBuilder();
            sb.append("HTTP/1.1").append(" ").append(200).append("OK").append("\r\n");
            sb.append("Content-Type:text/html;charset=utf-8").append("\r\n");
            //内容
            String str = "<html><head><title>响应结果</title></head><body>成功</body></html>";
            sb.append("Content-Length:"+str.getBytes("utf-8").length).append("\r\n");
            sb.append("\r\n");
            sb.append(str);

            //通过输出流发送出去
            BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(client.getOutputStream(),"utf-8"));
            bw.write(sb.toString());
            bw.flush();
            bw.close();*/
            Response rep = new Response(client.getOutputStream());
            Servlet servlet = WebApp.getServlet(req.getUrl());
            int code = 200;
            if (servlet == null){
                code = 404;
            }
            //调用Servlet中的服务的方法
            try {
                servlet.service(req,rep);
            } catch (Exception e) {
                e.printStackTrace();
            }
            rep.pushToClient(code);
            IOCloseUtil.closeALL(client);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void stop(){

    }
}
